//+------------------------------------------------------------------+
//|                                              Hull moving average |
//|                                                          HMA.mq4 |
//| www.forex-tsd.com elite section only                             |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1 Yellow
#property indicator_color2 Green
#property indicator_color3 Green
#property indicator_color4 Orange
#property indicator_color5 Orange
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 2

//
//
//
//
//

extern string TimeFrame  = "current time frame";
extern int    HMAPeriod  = 20;
extern int    HMAPrice   = PRICE_CLOSE;
extern int    HMAMethod  = MODE_LWMA;
extern int    HMAShift   = 0;

//
//
//
//
//

double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
double buffer5[];

//
//
//
//
//

int    HalfPeriod;
int    HullPeriod;
int    timeFrame;
string IndicatorFileName;
bool   calculatingHMA = false;
bool   returningBars  = false;


//+------------------------------------------------------------------
//|                                                                 |
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   HMAPeriod  = MathMax(2,HMAPeriod);
   HalfPeriod = MathFloor(HMAPeriod/2);
   HullPeriod = MathFloor(MathSqrt(HMAPeriod));
   
   //
   //
   //
   //
   //
   
      SetIndexBuffer(0,buffer1);
      SetIndexBuffer(1,buffer2);
      if (TimeFrame=="calculateHMA")
         {
            calculatingHMA = true;
            return(0);
         }            
      if (TimeFrame=="returnBars")
         {
            returningBars = true;
            return(0);
         }            
      SetIndexBuffer(2,buffer3);
      SetIndexBuffer(3,buffer4);
      SetIndexBuffer(4,buffer5);

   //
   //
   //
   //
   //
   
   timeFrame = stringToTimeFrame(TimeFrame);
      for (int i=0;i<5;i++) SetIndexShift(i,HMAShift*timeFrame/Period());
   IndicatorFileName = WindowExpertName();
   IndicatorShortName("HMA "+TimeFrameToString(timeFrame)+" ("+HMAPeriod+")");
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
   int limit,i;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;   
           limit=Bars-counted_bars;

   if (returningBars)  { buffer1[0] = limit;  return(0); }
   if (calculatingHMA) { CalculateHMA(limit); return(0); }

   //
   //
   //
   //
   //
            
      if (timeFrame > Period()) limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,IndicatorFileName,"returnBars",0,0)*timeFrame/Period()));
      if (buffer1[limit] > buffer1[limit+1]) CleanPoint(limit,buffer2,buffer3);
      if (buffer1[limit] < buffer1[limit+1]) CleanPoint(limit,buffer4,buffer5);

      //
      //
      //
      //
      //
   
   	for(i = limit; i >= 0; i--)
      {
         int      shift1 = iBarShift(NULL,timeFrame,Time[i]);
         datetime time1  = iTime    (NULL,timeFrame,shift1);
   
            buffer1[i] = iCustom(NULL,timeFrame,IndicatorFileName,"calculateHMA",HMAPeriod,HMAPrice,HMAMethod,0,shift1);

            if(timeFrame <= Period() || shift1==iBarShift(NULL,timeFrame,Time[i-1])) continue;

            //
            //
	         //
            //
            //
		 
            for(int n = 1; i+n < Bars && Time[i+n] >= time1; n++) continue;	
            double factor = 1.0 / n;
            for(int k = 1; k < n; k++)
    	             buffer1[i+k] = k*factor*buffer1[i+n] + (1.0-k*factor)*buffer1[i];
      }
   	for(i = limit; i >= 0; i--)
      {	
         buffer2[i] = EMPTY_VALUE;
         buffer3[i] = EMPTY_VALUE;
         buffer4[i] = EMPTY_VALUE;
         buffer5[i] = EMPTY_VALUE;
            if (buffer1[i] > buffer1[i+1]) PlotPoint(i,buffer2,buffer3,buffer1);
            if (buffer1[i] < buffer1[i+1]) PlotPoint(i,buffer4,buffer5,buffer1);
      }                  
   
   //
   //
   //
   //
   //
      
   return(0);
}

//+------------------------------------------------------------------+
//|
//+------------------------------------------------------------------+
//
//
//
//
//

void CalculateHMA(int limit)
{
   int i;
   for(i=limit; i>=0; i--) buffer2[i] = iMA(NULL,0,HalfPeriod,0,HMAMethod,HMAPrice,i)*2-
                                        iMA(NULL,0,HMAPeriod ,0,HMAMethod,HMAPrice,i);
   for(i=limit; i>=0; i--) buffer1[i] = iMAOnArray(buffer2,0,HullPeriod,0,HMAMethod,i);
}   

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
      if (first[i+2] == EMPTY_VALUE) {
          first[i]    = from[i];
          first[i+1]  = from[i+1];
          second[i]   = EMPTY_VALUE;
         }
      else {
          second[i]   = from[i];
          second[i+1] = from[i+1];
          first[i]    = EMPTY_VALUE;
         }
      }
   else
      {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}

//+------------------------------------------------------------------+
//|
//+------------------------------------------------------------------+
//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   int tf=0;
       tfs = StringTrimLeft(StringTrimRight(StringUpperCase(tfs)));
         if (tfs=="M1" || tfs=="1")     tf=PERIOD_M1;
         if (tfs=="M5" || tfs=="5")     tf=PERIOD_M5;
         if (tfs=="M15"|| tfs=="15")    tf=PERIOD_M15;
         if (tfs=="M30"|| tfs=="30")    tf=PERIOD_M30;
         if (tfs=="H1" || tfs=="60")    tf=PERIOD_H1;
         if (tfs=="H4" || tfs=="240")   tf=PERIOD_H4;
         if (tfs=="D1" || tfs=="1440")  tf=PERIOD_D1;
         if (tfs=="W1" || tfs=="10080") tf=PERIOD_W1;
         if (tfs=="MN" || tfs=="43200") tf=PERIOD_MN1;
         if (tf<Period()) tf=Period();
  return(tf);
}
string TimeFrameToString(int tf)
{
   string tfs="";
   
   if (tf!=Period())
      switch(tf) {
         case PERIOD_M1:  tfs="M1"  ; break;
         case PERIOD_M5:  tfs="M5"  ; break;
         case PERIOD_M15: tfs="M15" ; break;
         case PERIOD_M30: tfs="M30" ; break;
         case PERIOD_H1:  tfs="H1"  ; break;
         case PERIOD_H4:  tfs="H4"  ; break;
         case PERIOD_D1:  tfs="D1"  ; break;
         case PERIOD_W1:  tfs="W1"  ; break;
         case PERIOD_MN1: tfs="MN1";
      }
   return(tfs);
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;
   int      lenght = StringLen(str) - 1;
   int      char;
   
   while(lenght >= 0)
      {
         char = StringGetChar(s, lenght);
         
         //
         //
         //
         //
         //
         
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                  s = StringSetChar(s, lenght, char - 32);
         else 
              if(char > -33 && char < 0)
                  s = StringSetChar(s, lenght, char + 224);
         lenght--;
   }
   return(s);
}